/*

	Modified for my usage.  I work with strings, the orignal works with
	files.

	 Thanks for the original to:

			    by John Walker
		       http://www.fourmilab.ch/

*/


#include <sys/types.h>

#include "yaunc.h"

typedef unsigned char byte;	      /* Byte type */

/*  ENCODE  --	Encode text strings into base64.  */

char *
encode(const char *src, size_t length)
{
	int i;
	byte dtable[256];
	int counter;
	char buffer[MAXLINE];
	char * mod_me = buffer;

    /*	Fill dtable with character encodings.  */

    for (i = 0; i < 26; i++) {
        dtable[i] = 'A' + i;
        dtable[26 + i] = 'a' + i;
    }
    for (i = 0; i < 10; i++) {
        dtable[52 + i] = '0' + i;
    }
    dtable[62] = '+';
    dtable[63] = '/';

   for (counter = 0; counter < length; counter++) 
	{
		byte igroup[3], ogroup[4];
		int c, n;

		igroup[0] = igroup[1] = igroup[2] = 0;
		/* initialize ingroup with 3 characters */
		for (n = 0; n < 3; n++, src++) 
		{
			c = *src;
			if (c == '\0') 
			{
				break;
			}
	
		igroup[n] = (byte) c;
		}

		/* if we have characters to convert, do so */
		if (n > 0) 
		{
			ogroup[0] = dtable[igroup[0] >> 2];
			ogroup[1] = dtable[((igroup[0] & 3) << 4) | (igroup[1] >> 4)];
			ogroup[2] = dtable[((igroup[1] & 0xF) << 2) | (igroup[2] >> 6)];
			ogroup[3] = dtable[igroup[2] & 0x3F];

            /* Replace characters in output stream with "=" pad
					characters if fewer than three characters were
					read from the end of the input stream. */

/* i don't need to pad stuff - the uptimes.net protocol doesn't seem
 	to require it
*/	
/*
			if (n < 3) 
			{
				ogroup[3] = '=';
				if (n < 2) 
				{
					ogroup[2] = '=';
				}
			}
*/

			/* write converted characters to output array */
			for (i = 0; i < 4; i++, mod_me++) 
			{
				*mod_me = ogroup[i];
			}
		}	/* end character conversion */
	}		/* end for loop */
/*
	if (fputs(eol, fo) == EOF) 
	{
	exit(1);
	}
*/

	++mod_me;
	*mod_me = '\0';

	return strdup(buffer);
}
